﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace Blue_Shadowz___Hash.Forms.Compare
{
    public partial class frmSHA1 : Form
    {
        public static int fileSize1;
        public static string fileName1;
        public static string returned1;
        public static int fileSize2;
        public static string fileName2;
        public static string returned2;
        public frmSHA1()
        {
            InitializeComponent();
        }

        private void frmSHA1_Load(object sender, EventArgs e)
        {
            OpenFileDialog ofd1 = new OpenFileDialog();
            if (ofd1.ShowDialog() == DialogResult.OK)
            {
                fileName1 = ofd1.FileName;
                txtFileDest.Text = fileName1;

                FileInfo fi = new FileInfo(fileName1);
                fileSize1 = Convert.ToInt32(fi.Length);

                if (fileSize1 > 209715200)
                {
                    MessageBox.Show("The file is larger than 200 megabytes, it might freeze the application. But it is still grabing the SHA-1! Don't close it!",
                        "Caution!",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                    GetChecksum1();
                    txtHash.Text = returned1;
                }
                else
                {
                    GetChecksum1();
                    txtHash.Text = returned1;
                }
            }

            OpenFileDialog ofd2 = new OpenFileDialog();
            if (ofd2.ShowDialog() == DialogResult.OK)
            {
                fileName2 = ofd2.FileName;
                txtFileDest2.Text = fileName2;

                FileInfo fi = new FileInfo(fileName2);
                fileSize2 = Convert.ToInt32(fi.Length);

                if (fileSize2 > 209715200)
                {
                    MessageBox.Show("The file is larger than 200 megabytes, it might freeze the application. But it is still grabing the SHA-1! Don't close it!",
                        "Caution!",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                    GetChecksum2();
                    txtHash2.Text = returned2;
                }
                else
                {
                    GetChecksum2();
                    txtHash2.Text = returned2;
                }
            }
        }

        private static void GetChecksum1()
        {
            using (FileStream stream = File.OpenRead(fileName1))
            {
                SHA1Managed sha1 = new SHA1Managed();
                byte[] checksum = sha1.ComputeHash(stream);
                returned1 = BitConverter.ToString(checksum).Replace("-", "");
            }
        }

        private static void GetChecksum2()
        {
            using (FileStream stream = File.OpenRead(fileName2))
            {
                SHA1Managed sha1 = new SHA1Managed();
                byte[] checksum = sha1.ComputeHash(stream);
                returned2 = BitConverter.ToString(checksum).Replace("-", "");
            }
        }

        private void btnClipboard_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtHash.Text);
            MessageBox.Show("Added to clipboard!" +
                Environment.NewLine +
                Environment.NewLine +
                txtHash.Text,
                "Done!",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }

        private void btnClipboard2_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtHash2.Text);
            MessageBox.Show("Added to clipboard!" +
                Environment.NewLine +
                Environment.NewLine +
                txtHash2.Text,
                "Done!",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }

        private void btnCompare_Click(object sender, EventArgs e)
        {
            if (returned1 == returned2)
            {
                MessageBox.Show("SHA-1 hashes are the same!", "Compared!", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
            else
            {
                MessageBox.Show("SHA-1 hashes arn't the same!", "Compared!", MessageBoxButtons.OK, MessageBoxIcon.Information);
            }
        }
    }
}
