﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace Blue_Shadowz___Hash.Forms.Open
{
    public partial class frmMD5 : Form
    {
        public static int fileSize;
        public static string fileName;
        public static string returned;
        public frmMD5()
        {
            InitializeComponent();
        }

        private void frmMD5_Load(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                fileName = ofd.FileName;
                txtFileDest.Text = fileName;
                this.Text = "MD5 - " + fileName;

                FileInfo fi = new FileInfo(fileName);
                fileSize = Convert.ToInt32(fi.Length);

                if (fileSize > 209715200)
                {
                    MessageBox.Show("The file is larger than 200 megabytes, it might freeze the application. But it is still grabing the MD5! Don't close it!",
                        "Caution!",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                    GetChecksum();
                    txtHash.Text = returned;
                }
                else
                {
                    GetChecksum();
                    txtHash.Text = returned;
                }
            }
        }

        private static void GetChecksum()
        {
            using (FileStream stream = File.OpenRead(fileName))
            {
                HMACMD5 md5 = new HMACMD5();
                byte[] checksum = md5.ComputeHash(stream);
                returned = BitConverter.ToString(checksum).Replace("-", "");
            }
        }

        private void btnClipboard_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtHash.Text);
            MessageBox.Show("Added to clipboard!" + 
                Environment.NewLine + 
                Environment.NewLine + 
                txtHash.Text,
                "Done!",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }
    }
}
