﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;

namespace Blue_Shadowz___Hash.Forms.Open
{
    public partial class frmSHA256 : Form
    {
        public static string fileName;
        public static string returned;
        public static int fileSize;
        public frmSHA256()
        {
            InitializeComponent();
        }

        private void frmSHA258_Load(object sender, EventArgs e)
        {
            OpenFileDialog ofd = new OpenFileDialog();
            if (ofd.ShowDialog() == DialogResult.OK)
            {
                fileName = ofd.FileName;
                txtFileDest.Text = fileName;
                this.Text = "SHA-256 - " + fileName;

                FileInfo fi = new FileInfo(fileName);
                fileSize = Convert.ToInt32(fi.Length);

                if (fileSize > 209715200)
                {
                    MessageBox.Show("The file is larger than 200 megabytes, it might freeze the application. But it is still grabing the SHA-256! Don't close it!",
                        "Caution!",
                        MessageBoxButtons.OK,
                        MessageBoxIcon.Information);
                    GetChecksum();
                    txtHash.Text = returned;
                }
                else
                {
                    GetChecksum();
                    txtHash.Text = returned;
                }
            }
        }

        private static void GetChecksum()
        {
            using (FileStream stream = File.OpenRead(fileName))
            {
                SHA256Managed sha256 = new SHA256Managed();
                byte[] checksum = sha256.ComputeHash(stream);
                returned = BitConverter.ToString(checksum).Replace("-", "");
            }
        }

        private void btnClipboard_Click(object sender, EventArgs e)
        {
            Clipboard.SetText(txtHash.Text);
            MessageBox.Show("Added to clipboard!" +
                Environment.NewLine +
                Environment.NewLine +
                txtHash.Text,
                "Done!",
                MessageBoxButtons.OK,
                MessageBoxIcon.Information);
        }
    }
}
